/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.7
        Device            :  PIC18F47Q10
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.31 and above
        MPLAB 	          :  MPLAB X 5.45	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set RAM_EN aliases
#define RAM_EN_TRIS                 TRISAbits.TRISA0
#define RAM_EN_LAT                  LATAbits.LATA0
#define RAM_EN_PORT                 PORTAbits.RA0
#define RAM_EN_WPU                  WPUAbits.WPUA0
#define RAM_EN_OD                   ODCONAbits.ODCA0
#define RAM_EN_ANS                  ANSELAbits.ANSELA0
#define RAM_EN_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define RAM_EN_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define RAM_EN_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define RAM_EN_GetValue()           PORTAbits.RA0
#define RAM_EN_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define RAM_EN_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define RAM_EN_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define RAM_EN_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define RAM_EN_SetPushPull()        do { ODCONAbits.ODCA0 = 0; } while(0)
#define RAM_EN_SetOpenDrain()       do { ODCONAbits.ODCA0 = 1; } while(0)
#define RAM_EN_SetAnalogMode()      do { ANSELAbits.ANSELA0 = 1; } while(0)
#define RAM_EN_SetDigitalMode()     do { ANSELAbits.ANSELA0 = 0; } while(0)

// get/set R_W_ aliases
#define R_W__TRIS                 TRISAbits.TRISA1
#define R_W__LAT                  LATAbits.LATA1
#define R_W__PORT                 PORTAbits.RA1
#define R_W__WPU                  WPUAbits.WPUA1
#define R_W__OD                   ODCONAbits.ODCA1
#define R_W__ANS                  ANSELAbits.ANSELA1
#define R_W__SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define R_W__SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define R_W__Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define R_W__GetValue()           PORTAbits.RA1
#define R_W__SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define R_W__SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define R_W__SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define R_W__ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define R_W__SetPushPull()        do { ODCONAbits.ODCA1 = 0; } while(0)
#define R_W__SetOpenDrain()       do { ODCONAbits.ODCA1 = 1; } while(0)
#define R_W__SetAnalogMode()      do { ANSELAbits.ANSELA1 = 1; } while(0)
#define R_W__SetDigitalMode()     do { ANSELAbits.ANSELA1 = 0; } while(0)

// get/set DS_ aliases
#define DS__TRIS                 TRISAbits.TRISA2
#define DS__LAT                  LATAbits.LATA2
#define DS__PORT                 PORTAbits.RA2
#define DS__WPU                  WPUAbits.WPUA2
#define DS__OD                   ODCONAbits.ODCA2
#define DS__ANS                  ANSELAbits.ANSELA2
#define DS__SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define DS__SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define DS__Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define DS__GetValue()           PORTAbits.RA2
#define DS__SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define DS__SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define DS__SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define DS__ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define DS__SetPushPull()        do { ODCONAbits.ODCA2 = 0; } while(0)
#define DS__SetOpenDrain()       do { ODCONAbits.ODCA2 = 1; } while(0)
#define DS__SetAnalogMode()      do { ANSELAbits.ANSELA2 = 1; } while(0)
#define DS__SetDigitalMode()     do { ANSELAbits.ANSELA2 = 0; } while(0)

// get/set IO_M aliases
#define IO_M_TRIS                 TRISAbits.TRISA3
#define IO_M_LAT                  LATAbits.LATA3
#define IO_M_PORT                 PORTAbits.RA3
#define IO_M_WPU                  WPUAbits.WPUA3
#define IO_M_OD                   ODCONAbits.ODCA3
#define IO_M_ANS                  ANSELAbits.ANSELA3
#define IO_M_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define IO_M_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define IO_M_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define IO_M_GetValue()           PORTAbits.RA3
#define IO_M_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define IO_M_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define IO_M_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define IO_M_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)
#define IO_M_SetPushPull()        do { ODCONAbits.ODCA3 = 0; } while(0)
#define IO_M_SetOpenDrain()       do { ODCONAbits.ODCA3 = 1; } while(0)
#define IO_M_SetAnalogMode()      do { ANSELAbits.ANSELA3 = 1; } while(0)
#define IO_M_SetDigitalMode()     do { ANSELAbits.ANSELA3 = 0; } while(0)

// get/set DTACK_ aliases
#define DTACK__TRIS                 TRISAbits.TRISA4
#define DTACK__LAT                  LATAbits.LATA4
#define DTACK__PORT                 PORTAbits.RA4
#define DTACK__WPU                  WPUAbits.WPUA4
#define DTACK__OD                   ODCONAbits.ODCA4
#define DTACK__ANS                  ANSELAbits.ANSELA4
#define DTACK__SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define DTACK__SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define DTACK__Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define DTACK__GetValue()           PORTAbits.RA4
#define DTACK__SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define DTACK__SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define DTACK__SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define DTACK__ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define DTACK__SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define DTACK__SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define DTACK__SetAnalogMode()      do { ANSELAbits.ANSELA4 = 1; } while(0)
#define DTACK__SetDigitalMode()     do { ANSELAbits.ANSELA4 = 0; } while(0)

// get/set SS_ aliases
#define SS__TRIS                 TRISAbits.TRISA5
#define SS__LAT                  LATAbits.LATA5
#define SS__PORT                 PORTAbits.RA5
#define SS__WPU                  WPUAbits.WPUA5
#define SS__OD                   ODCONAbits.ODCA5
#define SS__ANS                  ANSELAbits.ANSELA5
#define SS__SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define SS__SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define SS__Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define SS__GetValue()           PORTAbits.RA5
#define SS__SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define SS__SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define SS__SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define SS__ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define SS__SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define SS__SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define SS__SetAnalogMode()      do { ANSELAbits.ANSELA5 = 1; } while(0)
#define SS__SetDigitalMode()     do { ANSELAbits.ANSELA5 = 0; } while(0)

// get/set MCU_RTS aliases
#define MCU_RTS_TRIS                 TRISBbits.TRISB0
#define MCU_RTS_LAT                  LATBbits.LATB0
#define MCU_RTS_PORT                 PORTBbits.RB0
#define MCU_RTS_WPU                  WPUBbits.WPUB0
#define MCU_RTS_OD                   ODCONBbits.ODCB0
#define MCU_RTS_ANS                  ANSELBbits.ANSELB0
#define MCU_RTS_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define MCU_RTS_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define MCU_RTS_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define MCU_RTS_GetValue()           PORTBbits.RB0
#define MCU_RTS_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define MCU_RTS_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define MCU_RTS_SetPullup()          do { WPUBbits.WPUB0 = 1; } while(0)
#define MCU_RTS_ResetPullup()        do { WPUBbits.WPUB0 = 0; } while(0)
#define MCU_RTS_SetPushPull()        do { ODCONBbits.ODCB0 = 0; } while(0)
#define MCU_RTS_SetOpenDrain()       do { ODCONBbits.ODCB0 = 1; } while(0)
#define MCU_RTS_SetAnalogMode()      do { ANSELBbits.ANSELB0 = 1; } while(0)
#define MCU_RTS_SetDigitalMode()     do { ANSELBbits.ANSELB0 = 0; } while(0)

// get/set RB1 procedures
#define RB1_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define RB1_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define RB1_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define RB1_GetValue()              PORTBbits.RB1
#define RB1_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define RB1_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define RB1_SetPullup()             do { WPUBbits.WPUB1 = 1; } while(0)
#define RB1_ResetPullup()           do { WPUBbits.WPUB1 = 0; } while(0)
#define RB1_SetAnalogMode()         do { ANSELBbits.ANSELB1 = 1; } while(0)
#define RB1_SetDigitalMode()        do { ANSELBbits.ANSELB1 = 0; } while(0)

// get/set RB2 procedures
#define RB2_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define RB2_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define RB2_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define RB2_GetValue()              PORTBbits.RB2
#define RB2_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define RB2_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define RB2_SetPullup()             do { WPUBbits.WPUB2 = 1; } while(0)
#define RB2_ResetPullup()           do { WPUBbits.WPUB2 = 0; } while(0)
#define RB2_SetAnalogMode()         do { ANSELBbits.ANSELB2 = 1; } while(0)
#define RB2_SetDigitalMode()        do { ANSELBbits.ANSELB2 = 0; } while(0)

// get/set INTA aliases
#define INTA_TRIS                 TRISBbits.TRISB3
#define INTA_LAT                  LATBbits.LATB3
#define INTA_PORT                 PORTBbits.RB3
#define INTA_WPU                  WPUBbits.WPUB3
#define INTA_OD                   ODCONBbits.ODCB3
#define INTA_ANS                  ANSELBbits.ANSELB3
#define INTA_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define INTA_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define INTA_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define INTA_GetValue()           PORTBbits.RB3
#define INTA_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define INTA_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define INTA_SetPullup()          do { WPUBbits.WPUB3 = 1; } while(0)
#define INTA_ResetPullup()        do { WPUBbits.WPUB3 = 0; } while(0)
#define INTA_SetPushPull()        do { ODCONBbits.ODCB3 = 0; } while(0)
#define INTA_SetOpenDrain()       do { ODCONBbits.ODCB3 = 1; } while(0)
#define INTA_SetAnalogMode()      do { ANSELBbits.ANSELB3 = 1; } while(0)
#define INTA_SetDigitalMode()     do { ANSELBbits.ANSELB3 = 0; } while(0)

// get/set RB4 procedures
#define RB4_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define RB4_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define RB4_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define RB4_GetValue()              PORTBbits.RB4
#define RB4_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define RB4_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define RB4_SetPullup()             do { WPUBbits.WPUB4 = 1; } while(0)
#define RB4_ResetPullup()           do { WPUBbits.WPUB4 = 0; } while(0)
#define RB4_SetAnalogMode()         do { ANSELBbits.ANSELB4 = 1; } while(0)
#define RB4_SetDigitalMode()        do { ANSELBbits.ANSELB4 = 0; } while(0)

// get/set RB5 procedures
#define RB5_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define RB5_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define RB5_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define RB5_GetValue()              PORTBbits.RB5
#define RB5_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define RB5_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define RB5_SetPullup()             do { WPUBbits.WPUB5 = 1; } while(0)
#define RB5_ResetPullup()           do { WPUBbits.WPUB5 = 0; } while(0)
#define RB5_SetAnalogMode()         do { ANSELBbits.ANSELB5 = 1; } while(0)
#define RB5_SetDigitalMode()        do { ANSELBbits.ANSELB5 = 0; } while(0)

// get/set USER_KEY aliases
#define USER_KEY_TRIS                 TRISBbits.TRISB6
#define USER_KEY_LAT                  LATBbits.LATB6
#define USER_KEY_PORT                 PORTBbits.RB6
#define USER_KEY_WPU                  WPUBbits.WPUB6
#define USER_KEY_OD                   ODCONBbits.ODCB6
#define USER_KEY_ANS                  ANSELBbits.ANSELB6
#define USER_KEY_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define USER_KEY_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define USER_KEY_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define USER_KEY_GetValue()           PORTBbits.RB6
#define USER_KEY_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define USER_KEY_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define USER_KEY_SetPullup()          do { WPUBbits.WPUB6 = 1; } while(0)
#define USER_KEY_ResetPullup()        do { WPUBbits.WPUB6 = 0; } while(0)
#define USER_KEY_SetPushPull()        do { ODCONBbits.ODCB6 = 0; } while(0)
#define USER_KEY_SetOpenDrain()       do { ODCONBbits.ODCB6 = 1; } while(0)
#define USER_KEY_SetAnalogMode()      do { ANSELBbits.ANSELB6 = 1; } while(0)
#define USER_KEY_SetDigitalMode()     do { ANSELBbits.ANSELB6 = 0; } while(0)

// get/set USER_LED aliases
#define USER_LED_TRIS                 TRISBbits.TRISB7
#define USER_LED_LAT                  LATBbits.LATB7
#define USER_LED_PORT                 PORTBbits.RB7
#define USER_LED_WPU                  WPUBbits.WPUB7
#define USER_LED_OD                   ODCONBbits.ODCB7
#define USER_LED_ANS                  ANSELBbits.ANSELB7
#define USER_LED_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define USER_LED_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define USER_LED_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define USER_LED_GetValue()           PORTBbits.RB7
#define USER_LED_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define USER_LED_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define USER_LED_SetPullup()          do { WPUBbits.WPUB7 = 1; } while(0)
#define USER_LED_ResetPullup()        do { WPUBbits.WPUB7 = 0; } while(0)
#define USER_LED_SetPushPull()        do { ODCONBbits.ODCB7 = 0; } while(0)
#define USER_LED_SetOpenDrain()       do { ODCONBbits.ODCB7 = 1; } while(0)
#define USER_LED_SetAnalogMode()      do { ANSELBbits.ANSELB7 = 1; } while(0)
#define USER_LED_SetDigitalMode()     do { ANSELBbits.ANSELB7 = 0; } while(0)

// get/set RC0 procedures
#define RC0_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define RC0_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define RC0_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define RC0_GetValue()              PORTCbits.RC0
#define RC0_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define RC0_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define RC0_SetPullup()             do { WPUCbits.WPUC0 = 1; } while(0)
#define RC0_ResetPullup()           do { WPUCbits.WPUC0 = 0; } while(0)
#define RC0_SetAnalogMode()         do { ANSELCbits.ANSELC0 = 1; } while(0)
#define RC0_SetDigitalMode()        do { ANSELCbits.ANSELC0 = 0; } while(0)

// get/set A0 aliases
#define A0_TRIS                 TRISCbits.TRISC1
#define A0_LAT                  LATCbits.LATC1
#define A0_PORT                 PORTCbits.RC1
#define A0_WPU                  WPUCbits.WPUC1
#define A0_OD                   ODCONCbits.ODCC1
#define A0_ANS                  ANSELCbits.ANSELC1
#define A0_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define A0_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define A0_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define A0_GetValue()           PORTCbits.RC1
#define A0_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define A0_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define A0_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define A0_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define A0_SetPushPull()        do { ODCONCbits.ODCC1 = 0; } while(0)
#define A0_SetOpenDrain()       do { ODCONCbits.ODCC1 = 1; } while(0)
#define A0_SetAnalogMode()      do { ANSELCbits.ANSELC1 = 1; } while(0)
#define A0_SetDigitalMode()     do { ANSELCbits.ANSELC1 = 0; } while(0)

// get/set A1 aliases
#define A1_TRIS                 TRISCbits.TRISC2
#define A1_LAT                  LATCbits.LATC2
#define A1_PORT                 PORTCbits.RC2
#define A1_WPU                  WPUCbits.WPUC2
#define A1_OD                   ODCONCbits.ODCC2
#define A1_ANS                  ANSELCbits.ANSELC2
#define A1_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define A1_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define A1_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define A1_GetValue()           PORTCbits.RC2
#define A1_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define A1_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define A1_SetPullup()          do { WPUCbits.WPUC2 = 1; } while(0)
#define A1_ResetPullup()        do { WPUCbits.WPUC2 = 0; } while(0)
#define A1_SetPushPull()        do { ODCONCbits.ODCC2 = 0; } while(0)
#define A1_SetOpenDrain()       do { ODCONCbits.ODCC2 = 1; } while(0)
#define A1_SetAnalogMode()      do { ANSELCbits.ANSELC2 = 1; } while(0)
#define A1_SetDigitalMode()     do { ANSELCbits.ANSELC2 = 0; } while(0)

// get/set RC3 procedures
#define RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define RC3_GetValue()              PORTCbits.RC3
#define RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define RC3_SetPullup()             do { WPUCbits.WPUC3 = 1; } while(0)
#define RC3_ResetPullup()           do { WPUCbits.WPUC3 = 0; } while(0)
#define RC3_SetAnalogMode()         do { ANSELCbits.ANSELC3 = 1; } while(0)
#define RC3_SetDigitalMode()        do { ANSELCbits.ANSELC3 = 0; } while(0)

// get/set RC4 procedures
#define RC4_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define RC4_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define RC4_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define RC4_GetValue()              PORTCbits.RC4
#define RC4_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define RC4_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define RC4_SetPullup()             do { WPUCbits.WPUC4 = 1; } while(0)
#define RC4_ResetPullup()           do { WPUCbits.WPUC4 = 0; } while(0)
#define RC4_SetAnalogMode()         do { ANSELCbits.ANSELC4 = 1; } while(0)
#define RC4_SetDigitalMode()        do { ANSELCbits.ANSELC4 = 0; } while(0)

// get/set RC5 procedures
#define RC5_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define RC5_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define RC5_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define RC5_GetValue()              PORTCbits.RC5
#define RC5_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define RC5_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define RC5_SetPullup()             do { WPUCbits.WPUC5 = 1; } while(0)
#define RC5_ResetPullup()           do { WPUCbits.WPUC5 = 0; } while(0)
#define RC5_SetAnalogMode()         do { ANSELCbits.ANSELC5 = 1; } while(0)
#define RC5_SetDigitalMode()        do { ANSELCbits.ANSELC5 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSELC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSELC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()              PORTCbits.RC7
#define RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define RC7_SetPullup()             do { WPUCbits.WPUC7 = 1; } while(0)
#define RC7_ResetPullup()           do { WPUCbits.WPUC7 = 0; } while(0)
#define RC7_SetAnalogMode()         do { ANSELCbits.ANSELC7 = 1; } while(0)
#define RC7_SetDigitalMode()        do { ANSELCbits.ANSELC7 = 0; } while(0)

// get/set D0 aliases
#define D0_TRIS                 TRISDbits.TRISD0
#define D0_LAT                  LATDbits.LATD0
#define D0_PORT                 PORTDbits.RD0
#define D0_WPU                  WPUDbits.WPUD0
#define D0_OD                   ODCONDbits.ODCD0
#define D0_ANS                  ANSELDbits.ANSELD0
#define D0_SetHigh()            do { LATDbits.LATD0 = 1; } while(0)
#define D0_SetLow()             do { LATDbits.LATD0 = 0; } while(0)
#define D0_Toggle()             do { LATDbits.LATD0 = ~LATDbits.LATD0; } while(0)
#define D0_GetValue()           PORTDbits.RD0
#define D0_SetDigitalInput()    do { TRISDbits.TRISD0 = 1; } while(0)
#define D0_SetDigitalOutput()   do { TRISDbits.TRISD0 = 0; } while(0)
#define D0_SetPullup()          do { WPUDbits.WPUD0 = 1; } while(0)
#define D0_ResetPullup()        do { WPUDbits.WPUD0 = 0; } while(0)
#define D0_SetPushPull()        do { ODCONDbits.ODCD0 = 0; } while(0)
#define D0_SetOpenDrain()       do { ODCONDbits.ODCD0 = 1; } while(0)
#define D0_SetAnalogMode()      do { ANSELDbits.ANSELD0 = 1; } while(0)
#define D0_SetDigitalMode()     do { ANSELDbits.ANSELD0 = 0; } while(0)

// get/set D1 aliases
#define D1_TRIS                 TRISDbits.TRISD1
#define D1_LAT                  LATDbits.LATD1
#define D1_PORT                 PORTDbits.RD1
#define D1_WPU                  WPUDbits.WPUD1
#define D1_OD                   ODCONDbits.ODCD1
#define D1_ANS                  ANSELDbits.ANSELD1
#define D1_SetHigh()            do { LATDbits.LATD1 = 1; } while(0)
#define D1_SetLow()             do { LATDbits.LATD1 = 0; } while(0)
#define D1_Toggle()             do { LATDbits.LATD1 = ~LATDbits.LATD1; } while(0)
#define D1_GetValue()           PORTDbits.RD1
#define D1_SetDigitalInput()    do { TRISDbits.TRISD1 = 1; } while(0)
#define D1_SetDigitalOutput()   do { TRISDbits.TRISD1 = 0; } while(0)
#define D1_SetPullup()          do { WPUDbits.WPUD1 = 1; } while(0)
#define D1_ResetPullup()        do { WPUDbits.WPUD1 = 0; } while(0)
#define D1_SetPushPull()        do { ODCONDbits.ODCD1 = 0; } while(0)
#define D1_SetOpenDrain()       do { ODCONDbits.ODCD1 = 1; } while(0)
#define D1_SetAnalogMode()      do { ANSELDbits.ANSELD1 = 1; } while(0)
#define D1_SetDigitalMode()     do { ANSELDbits.ANSELD1 = 0; } while(0)

// get/set D2 aliases
#define D2_TRIS                 TRISDbits.TRISD2
#define D2_LAT                  LATDbits.LATD2
#define D2_PORT                 PORTDbits.RD2
#define D2_WPU                  WPUDbits.WPUD2
#define D2_OD                   ODCONDbits.ODCD2
#define D2_ANS                  ANSELDbits.ANSELD2
#define D2_SetHigh()            do { LATDbits.LATD2 = 1; } while(0)
#define D2_SetLow()             do { LATDbits.LATD2 = 0; } while(0)
#define D2_Toggle()             do { LATDbits.LATD2 = ~LATDbits.LATD2; } while(0)
#define D2_GetValue()           PORTDbits.RD2
#define D2_SetDigitalInput()    do { TRISDbits.TRISD2 = 1; } while(0)
#define D2_SetDigitalOutput()   do { TRISDbits.TRISD2 = 0; } while(0)
#define D2_SetPullup()          do { WPUDbits.WPUD2 = 1; } while(0)
#define D2_ResetPullup()        do { WPUDbits.WPUD2 = 0; } while(0)
#define D2_SetPushPull()        do { ODCONDbits.ODCD2 = 0; } while(0)
#define D2_SetOpenDrain()       do { ODCONDbits.ODCD2 = 1; } while(0)
#define D2_SetAnalogMode()      do { ANSELDbits.ANSELD2 = 1; } while(0)
#define D2_SetDigitalMode()     do { ANSELDbits.ANSELD2 = 0; } while(0)

// get/set D3 aliases
#define D3_TRIS                 TRISDbits.TRISD3
#define D3_LAT                  LATDbits.LATD3
#define D3_PORT                 PORTDbits.RD3
#define D3_WPU                  WPUDbits.WPUD3
#define D3_OD                   ODCONDbits.ODCD3
#define D3_ANS                  ANSELDbits.ANSELD3
#define D3_SetHigh()            do { LATDbits.LATD3 = 1; } while(0)
#define D3_SetLow()             do { LATDbits.LATD3 = 0; } while(0)
#define D3_Toggle()             do { LATDbits.LATD3 = ~LATDbits.LATD3; } while(0)
#define D3_GetValue()           PORTDbits.RD3
#define D3_SetDigitalInput()    do { TRISDbits.TRISD3 = 1; } while(0)
#define D3_SetDigitalOutput()   do { TRISDbits.TRISD3 = 0; } while(0)
#define D3_SetPullup()          do { WPUDbits.WPUD3 = 1; } while(0)
#define D3_ResetPullup()        do { WPUDbits.WPUD3 = 0; } while(0)
#define D3_SetPushPull()        do { ODCONDbits.ODCD3 = 0; } while(0)
#define D3_SetOpenDrain()       do { ODCONDbits.ODCD3 = 1; } while(0)
#define D3_SetAnalogMode()      do { ANSELDbits.ANSELD3 = 1; } while(0)
#define D3_SetDigitalMode()     do { ANSELDbits.ANSELD3 = 0; } while(0)

// get/set D4 aliases
#define D4_TRIS                 TRISDbits.TRISD4
#define D4_LAT                  LATDbits.LATD4
#define D4_PORT                 PORTDbits.RD4
#define D4_WPU                  WPUDbits.WPUD4
#define D4_OD                   ODCONDbits.ODCD4
#define D4_ANS                  ANSELDbits.ANSELD4
#define D4_SetHigh()            do { LATDbits.LATD4 = 1; } while(0)
#define D4_SetLow()             do { LATDbits.LATD4 = 0; } while(0)
#define D4_Toggle()             do { LATDbits.LATD4 = ~LATDbits.LATD4; } while(0)
#define D4_GetValue()           PORTDbits.RD4
#define D4_SetDigitalInput()    do { TRISDbits.TRISD4 = 1; } while(0)
#define D4_SetDigitalOutput()   do { TRISDbits.TRISD4 = 0; } while(0)
#define D4_SetPullup()          do { WPUDbits.WPUD4 = 1; } while(0)
#define D4_ResetPullup()        do { WPUDbits.WPUD4 = 0; } while(0)
#define D4_SetPushPull()        do { ODCONDbits.ODCD4 = 0; } while(0)
#define D4_SetOpenDrain()       do { ODCONDbits.ODCD4 = 1; } while(0)
#define D4_SetAnalogMode()      do { ANSELDbits.ANSELD4 = 1; } while(0)
#define D4_SetDigitalMode()     do { ANSELDbits.ANSELD4 = 0; } while(0)

// get/set D5 aliases
#define D5_TRIS                 TRISDbits.TRISD5
#define D5_LAT                  LATDbits.LATD5
#define D5_PORT                 PORTDbits.RD5
#define D5_WPU                  WPUDbits.WPUD5
#define D5_OD                   ODCONDbits.ODCD5
#define D5_ANS                  ANSELDbits.ANSELD5
#define D5_SetHigh()            do { LATDbits.LATD5 = 1; } while(0)
#define D5_SetLow()             do { LATDbits.LATD5 = 0; } while(0)
#define D5_Toggle()             do { LATDbits.LATD5 = ~LATDbits.LATD5; } while(0)
#define D5_GetValue()           PORTDbits.RD5
#define D5_SetDigitalInput()    do { TRISDbits.TRISD5 = 1; } while(0)
#define D5_SetDigitalOutput()   do { TRISDbits.TRISD5 = 0; } while(0)
#define D5_SetPullup()          do { WPUDbits.WPUD5 = 1; } while(0)
#define D5_ResetPullup()        do { WPUDbits.WPUD5 = 0; } while(0)
#define D5_SetPushPull()        do { ODCONDbits.ODCD5 = 0; } while(0)
#define D5_SetOpenDrain()       do { ODCONDbits.ODCD5 = 1; } while(0)
#define D5_SetAnalogMode()      do { ANSELDbits.ANSELD5 = 1; } while(0)
#define D5_SetDigitalMode()     do { ANSELDbits.ANSELD5 = 0; } while(0)

// get/set D6 aliases
#define D6_TRIS                 TRISDbits.TRISD6
#define D6_LAT                  LATDbits.LATD6
#define D6_PORT                 PORTDbits.RD6
#define D6_WPU                  WPUDbits.WPUD6
#define D6_OD                   ODCONDbits.ODCD6
#define D6_ANS                  ANSELDbits.ANSELD6
#define D6_SetHigh()            do { LATDbits.LATD6 = 1; } while(0)
#define D6_SetLow()             do { LATDbits.LATD6 = 0; } while(0)
#define D6_Toggle()             do { LATDbits.LATD6 = ~LATDbits.LATD6; } while(0)
#define D6_GetValue()           PORTDbits.RD6
#define D6_SetDigitalInput()    do { TRISDbits.TRISD6 = 1; } while(0)
#define D6_SetDigitalOutput()   do { TRISDbits.TRISD6 = 0; } while(0)
#define D6_SetPullup()          do { WPUDbits.WPUD6 = 1; } while(0)
#define D6_ResetPullup()        do { WPUDbits.WPUD6 = 0; } while(0)
#define D6_SetPushPull()        do { ODCONDbits.ODCD6 = 0; } while(0)
#define D6_SetOpenDrain()       do { ODCONDbits.ODCD6 = 1; } while(0)
#define D6_SetAnalogMode()      do { ANSELDbits.ANSELD6 = 1; } while(0)
#define D6_SetDigitalMode()     do { ANSELDbits.ANSELD6 = 0; } while(0)

// get/set D7 aliases
#define D7_TRIS                 TRISDbits.TRISD7
#define D7_LAT                  LATDbits.LATD7
#define D7_PORT                 PORTDbits.RD7
#define D7_WPU                  WPUDbits.WPUD7
#define D7_OD                   ODCONDbits.ODCD7
#define D7_ANS                  ANSELDbits.ANSELD7
#define D7_SetHigh()            do { LATDbits.LATD7 = 1; } while(0)
#define D7_SetLow()             do { LATDbits.LATD7 = 0; } while(0)
#define D7_Toggle()             do { LATDbits.LATD7 = ~LATDbits.LATD7; } while(0)
#define D7_GetValue()           PORTDbits.RD7
#define D7_SetDigitalInput()    do { TRISDbits.TRISD7 = 1; } while(0)
#define D7_SetDigitalOutput()   do { TRISDbits.TRISD7 = 0; } while(0)
#define D7_SetPullup()          do { WPUDbits.WPUD7 = 1; } while(0)
#define D7_ResetPullup()        do { WPUDbits.WPUD7 = 0; } while(0)
#define D7_SetPushPull()        do { ODCONDbits.ODCD7 = 0; } while(0)
#define D7_SetOpenDrain()       do { ODCONDbits.ODCD7 = 1; } while(0)
#define D7_SetAnalogMode()      do { ANSELDbits.ANSELD7 = 1; } while(0)
#define D7_SetDigitalMode()     do { ANSELDbits.ANSELD7 = 0; } while(0)

// get/set RESET_ aliases
#define RESET__TRIS                 TRISEbits.TRISE0
#define RESET__LAT                  LATEbits.LATE0
#define RESET__PORT                 PORTEbits.RE0
#define RESET__WPU                  WPUEbits.WPUE0
#define RESET__OD                   ODCONEbits.ODCE0
#define RESET__ANS                  ANSELEbits.ANSELE0
#define RESET__SetHigh()            do { LATEbits.LATE0 = 1; } while(0)
#define RESET__SetLow()             do { LATEbits.LATE0 = 0; } while(0)
#define RESET__Toggle()             do { LATEbits.LATE0 = ~LATEbits.LATE0; } while(0)
#define RESET__GetValue()           PORTEbits.RE0
#define RESET__SetDigitalInput()    do { TRISEbits.TRISE0 = 1; } while(0)
#define RESET__SetDigitalOutput()   do { TRISEbits.TRISE0 = 0; } while(0)
#define RESET__SetPullup()          do { WPUEbits.WPUE0 = 1; } while(0)
#define RESET__ResetPullup()        do { WPUEbits.WPUE0 = 0; } while(0)
#define RESET__SetPushPull()        do { ODCONEbits.ODCE0 = 0; } while(0)
#define RESET__SetOpenDrain()       do { ODCONEbits.ODCE0 = 1; } while(0)
#define RESET__SetAnalogMode()      do { ANSELEbits.ANSELE0 = 1; } while(0)
#define RESET__SetDigitalMode()     do { ANSELEbits.ANSELE0 = 0; } while(0)

// get/set HALT_ aliases
#define HALT__TRIS                 TRISEbits.TRISE1
#define HALT__LAT                  LATEbits.LATE1
#define HALT__PORT                 PORTEbits.RE1
#define HALT__WPU                  WPUEbits.WPUE1
#define HALT__OD                   ODCONEbits.ODCE1
#define HALT__ANS                  ANSELEbits.ANSELE1
#define HALT__SetHigh()            do { LATEbits.LATE1 = 1; } while(0)
#define HALT__SetLow()             do { LATEbits.LATE1 = 0; } while(0)
#define HALT__Toggle()             do { LATEbits.LATE1 = ~LATEbits.LATE1; } while(0)
#define HALT__GetValue()           PORTEbits.RE1
#define HALT__SetDigitalInput()    do { TRISEbits.TRISE1 = 1; } while(0)
#define HALT__SetDigitalOutput()   do { TRISEbits.TRISE1 = 0; } while(0)
#define HALT__SetPullup()          do { WPUEbits.WPUE1 = 1; } while(0)
#define HALT__ResetPullup()        do { WPUEbits.WPUE1 = 0; } while(0)
#define HALT__SetPushPull()        do { ODCONEbits.ODCE1 = 0; } while(0)
#define HALT__SetOpenDrain()       do { ODCONEbits.ODCE1 = 1; } while(0)
#define HALT__SetAnalogMode()      do { ANSELEbits.ANSELE1 = 1; } while(0)
#define HALT__SetDigitalMode()     do { ANSELEbits.ANSELE1 = 0; } while(0)

// get/set IPL1_ aliases
#define IPL1__TRIS                 TRISEbits.TRISE2
#define IPL1__LAT                  LATEbits.LATE2
#define IPL1__PORT                 PORTEbits.RE2
#define IPL1__WPU                  WPUEbits.WPUE2
#define IPL1__OD                   ODCONEbits.ODCE2
#define IPL1__ANS                  ANSELEbits.ANSELE2
#define IPL1__SetHigh()            do { LATEbits.LATE2 = 1; } while(0)
#define IPL1__SetLow()             do { LATEbits.LATE2 = 0; } while(0)
#define IPL1__Toggle()             do { LATEbits.LATE2 = ~LATEbits.LATE2; } while(0)
#define IPL1__GetValue()           PORTEbits.RE2
#define IPL1__SetDigitalInput()    do { TRISEbits.TRISE2 = 1; } while(0)
#define IPL1__SetDigitalOutput()   do { TRISEbits.TRISE2 = 0; } while(0)
#define IPL1__SetPullup()          do { WPUEbits.WPUE2 = 1; } while(0)
#define IPL1__ResetPullup()        do { WPUEbits.WPUE2 = 0; } while(0)
#define IPL1__SetPushPull()        do { ODCONEbits.ODCE2 = 0; } while(0)
#define IPL1__SetOpenDrain()       do { ODCONEbits.ODCE2 = 1; } while(0)
#define IPL1__SetAnalogMode()      do { ANSELEbits.ANSELE2 = 1; } while(0)
#define IPL1__SetDigitalMode()     do { ANSELEbits.ANSELE2 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/